From 3a5d27f385e14cf98b60114d32a9c350f64332f1 Mon Sep 17 00:00:00 2001
From: Ida Dittrich <i.dittrich@valueon.ch>
Date: Mon, 5 Jan 2026 15:12:13 +0100
Subject: [PATCH 2/5] feat:chatbot weiterimplementiert

---
 modules/connectors/connectorPreprocessor.py   |   24 +-
 modules/features/chatbot/mainChatbot.py       | 1446 +++++++----------
 modules/interfaces/interfaceDbChatObjects.py  |   60 +-
 .../methods/methodAi/actions/process.py       |   25 +-
 4 files changed, 667 insertions(+), 888 deletions(-)

diff --git a/modules/connectors/connectorPreprocessor.py b/modules/connectors/connectorPreprocessor.py
index a1aa8368..189b6e2b 100644
--- a/modules/connectors/connectorPreprocessor.py
+++ b/modules/connectors/connectorPreprocessor.py
@@ -39,15 +39,17 @@ class PreprocessorConnector:
         
         logger.info("PreprocessorConnector initialized")
     
-    async def executeQuery(self, sql_query: str) -> str:
+    async def executeQuery(self, sql_query: str, return_json: bool = False):
         """
         Execute a SQL query via the preprocessing API.
         
         Args:
             sql_query: SQL SELECT query to execute
+            return_json: If True, returns dict with 'text' and 'data' keys. If False, returns formatted string.
             
         Returns:
-            Formatted result string with query results
+            If return_json=False: Formatted result string with query results
+            If return_json=True: Dict with 'text' (formatted string) and 'data' (raw JSON data list)
             
         Raises:
             ValueError: If query is invalid or contains forbidden keywords
@@ -57,16 +59,22 @@ class PreprocessorConnector:
             # Validate query
             validation_error = self._validateQuery(sql_query)
             if validation_error:
+                if return_json:
+                    return {"text": validation_error, "data": []}
                 return validation_error
             
             # Check configuration
             if not self.api_key:
                 error_msg = "Error: PP_QUERY_API_KEY not configured"
                 logger.error(error_msg)
+                if return_json:
+                    return {"text": error_msg, "data": []}
                 return error_msg
             if not self.base_url:
                 error_msg = "Error: PP_QUERY_BASE_URL not configured"
                 logger.error(error_msg)
+                if return_json:
+                    return {"text": error_msg, "data": []}
                 return error_msg
             
             # Make HTTP POST request to preprocessing API
@@ -86,7 +94,10 @@ class PreprocessorConnector:
             # Parse response
             if not result.get("success"):
                 error_message = result.get("message", "Unknown error")
-                return f"Query failed: {error_message}"
+                error_text = f"Query failed: {error_message}"
+                if return_json:
+                    return {"text": error_text, "data": []}
+                return error_text
             
             # Format results
             data = result.get("data", [])
@@ -97,7 +108,10 @@ class PreprocessorConnector:
             
             # Format results as string
             if not display_data:
-                return f"Query executed successfully. Returned {row_count} rows (no data)."
+                result_text = f"Query executed successfully. Returned {row_count} rows (no data)."
+                if return_json:
+                    return {"text": result_text, "data": data}
+                return result_text
             
             # Format each row
             results = []
@@ -110,6 +124,8 @@ class PreprocessorConnector:
                 + "\n".join(results)
             )
             
+            if return_json:
+                return {"text": result_text, "data": data}
             return result_text
             
         except httpx.HTTPStatusError as e:
